#!/bin/bash
#Used to create the config files needed for the PGCluster replication server:

source $1
source /tmp/$STATIC_CONFIG_FILE

echo "Configuring replication instance. Config file: $1"

NUMBER_OF_REPLICAS=$3

LOAD_BALANCER_NODE=${ALL_REMOTE_INSTANCES[@]:0:1}
REPLICATION_SERVER_NODE=${ALL_REMOTE_INSTANCES[@]:1:1}

FIRST_DATA_NODE=$2

let MINUS_ONE=$NUMBER_OF_REPLICAS-1
DATA_NODES=("${ALL_REMOTE_INSTANCES[@]:2:$MINUS_ONE}")

DATA_NODES[$[${#DATA_NODES[@]}+1]]=$FIRST_DATA_NODE




echo "REP"
echo "NUMBER_OF_REPLICAS = $NUMBER_OF_REPLICAS"
echo "LOAD_BALANCER_NODE = $LOAD_BALANCER_NODE"
echo "REPLICATION_SERVER_NODE = $REPLICATION_SERVER_NODE"
echo "DATA_NODES = ${DATA_NODES[@]}"

#pg_hba.conf:
echo "local all all trust" > $HBA_CONFIG_FILE

for i in "${IP_ADDRESSES[@]}"
do
    echo "host all all $i trust" >> $HBA_CONFIG_FILE  
done

#pg_replicate.conf:

echo "" > $PG_REPLICATE_CONF

for i in "${DATA_NODES[@]}"
do
	echo "<Cluster_Server_Info>" >> $PG_REPLICATE_CONF
	echo "<Host_Name>$i</Host_Name>" >> $PG_REPLICATE_CONF
	echo "<Port>$DATA_NODE_PORT</Port>" >> $PG_REPLICATE_CONF
	echo "<Recovery_Port>7001</Recovery_Port>" >> $PG_REPLICATE_CONF
	echo "</Cluster_Server_Info>" >> $PG_REPLICATE_CONF
done



echo "<LoadBalance_Server_Info>" >> $PG_REPLICATE_CONF
echo "<Host_Name>$LOAD_BALANCER_NODE</Host_Name>" >> $PG_REPLICATE_CONF
echo "<Recovery_Port>6001</Recovery_Port>" >> $PG_REPLICATE_CONF
echo "</LoadBalance_Server_Info>" >> $PG_REPLICATE_CONF

echo "<Host_Name>$REPLICATION_SERVER_NODE</Host_Name>" >> $PG_REPLICATE_CONF
echo "<Replication_Port>8001</Replication_Port>" >> $PG_REPLICATE_CONF
echo "<Recovery_Port>8101</Recovery_Port>" >> $PG_REPLICATE_CONF
echo "<RLOG_Port>8301</RLOG_Port>" >> $PG_REPLICATE_CONF
echo "<Response_Mode>normal</Response_Mode>" >> $PG_REPLICATE_CONF
echo "<Use_Replication_Log>no</Use_Replication_Log>" >> $PG_REPLICATE_CONF
echo "<Replication_Timeout>1min</Replication_Timeout>" >> $PG_REPLICATE_CONF
echo "<LifeCheck_Timeout>3s</LifeCheck_Timeout>" >> $PG_REPLICATE_CONF
echo "<LifeCheck_Interval>15s</LifeCheck_Interval>" >> $PG_REPLICATE_CONF


echo "<Log_File_Info>" >> $PG_REPLICATE_CONF
echo "<File_Name>$PG_REPLICATE_LOG_FILE</File_Name>" >> $PG_REPLICATE_CONF
echo "<File_Size>1M </File_Size>" >> $PG_REPLICATE_CONF
echo "<Rotate>3</Rotate>" >> $PG_REPLICATE_CONF
echo "</Log_File_Info>" >> $PG_REPLICATE_CONF

HOSTNAME=`hostname`
echo "Log files on written successfully on $HOSTNAME"

